* Call Indicator Using Motorola Micro-controller MC68HC705J1A.
* Developed By : Uday B.Mujumdar,Lecturer, Shri Ramdeobaba Kamla Nehru Engineering
*                College,Nagpur.
**************************************************************************************
                                  org  $00c0
digit_1                         rmb  1  ;
digit_2                         rmb  1  ;
digit_3                         rmb  1  ;
position_1                      rmb  1  ;
position_2                      rmb  1  ;
position_3                      rmb  1  ;
adc_data1                       rmb  1  ;
adc_data2                       rmb  1  ;
address                         rmb  1  ;
disp_Address                    rmb  1  ;
count1                          rmb  1  ;
count2                          rmb  1  ;
number1                         rmb  1  ;
number2                         rmb  1  ;
data_Out1                       rmb  1  ;
data_Out2                       rmb  1  ;
buzzer                           rmb  1  ;
debounce                         rmb  1  ;
* Pending call storing :From D3 to F6.

*memory  area equates
ramstart   equ   $00c0
romstart   equ   $0300
vectors    equ   $07f8

*interrupt &reset  vector area

         org  $07f8
timvec   fdb  timer
irqvec   fdb  snooze
swivec   fdb  start
resvec   fdb  start


porta    equ  $00
pa7      equ  7
pa6      equ  6
pa5      equ  5
pa4      equ  4
pa3      equ  3
pa2      equ  2
pa1      equ  1
pa0      equ  0
pa7.     equ  $80
pa6.     equ  $40
pa5.     equ  $20
pa4.     equ  $10
pa3.     equ  $08
pa2.     equ  $04
pa1.     equ  $02
pa0.     equ  $01

portb    equ  $01

pb5      equ  5
pb4      equ  4
pb3      equ  3
pb2      equ  2
pb1      equ  1
pb0      equ  0

pb5.     equ  $20
pb4.     equ  $10
pb3.     equ  $08
pb2.     equ  $04
pb1.     equ  $02
pb0.     equ  $01


ddra     equ  $04
ddra7    equ  7
ddra6    equ  6
ddra5    equ  5
ddra4    equ  4
ddra3    equ  3
ddra2    equ  2
ddra1    equ  1
ddra0    equ  0
ddra7.   equ  $80
ddra6.   equ  $40
ddra5.   equ  $20
ddra4.   equ  $10
ddra3.   equ  $08
ddra2.   equ  $04
ddra1.   equ  $02
ddra0.   equ  $01


ddrb     equ  $05
ddrb5    equ  5
ddrb4    equ  4
ddrb3    equ  3
ddrb2    equ  2
ddrb1    equ  1
ddrb0    equ  0
ddrb5.   equ  $20
ddrb4.   equ  $10
ddrb3.   equ  $08
ddrb2.   equ  $04
ddrb1.   equ  $02
ddrb0.   equ  $01


tscr     equ  $08
tof      equ  7
rtif     equ  6
toie     equ  5
rtie     equ  4
tofr     equ  3
rtifr    equ  2
rt1      equ  1
rt0      equ  0


tof.     equ  $80
rtif.    equ  $40
toie.    equ  $20
rtie.    equ  $10
tofr.    equ  $08
rtifr.   equ  $04
rt1.     equ  $02
rt0.     equ  $01

tcr      equ  $09

eprog   equ   $18
elat    equ   2
mpgm    equ   1
epgm    equ   0
elat.   equ   $04
mpgm.   equ   $02
epgm.   equ   $01

copr    equ   $07f0
copc    equ   0
copc.   equ   $01

mor     equ   $07f1
cop     equ   0
copen.  equ   $01

************************************************************************************
                          org  mor
            fcb   $01                   ;Watchdog Timer
************************************************************************************
                          org  $0300
* Crystal Frequency is 3.2768MHz.This gives the Internal Clock Frequency of
* Crystal Frequency/2 = 1.6384MHz.
* The Timer interrupt can be programmed to give interrupt after every 16,384,
* cycles by selecting rt1 and rt2 in timer status and control register.
* Here the Timer is programmed to provide an interrupt after every 10 miliseconds.
* i.e. 16384 cycles.For this option rt0 = rt1 = 0.
*************************************************************************************
start      cli                           ; clear interrupt
           bset    rtie,tscr             ; Activate the Timer Interrupt.
           bclr    rt1,tscr
           bclr    rt0,tscr
************************************************************************************
* Initilization :-In initialization; the port pins are assigned as input or output
*         as per the circuit connections.
*         Port A pins are used for Display of data as well as for  reading the ADC
*         Data.
*         Port B pins are used for controlling the ADC and Multiplexer.The Port B
*         pins are connected as:
*         Pb5: Read of ADC; Pb4 : Write of ADC;  Pb3 : Interrupt from  ADC;
*         Pb2: For Channel Selection of 4051; Pb1 :Mode Selection;
*         Pb0 : Latch Enable.
*         Keep the display and Buzzer off initially.
***********************************************************************************
InitA     lda      #%10111111
          sta      porta
          lda      #%11111111
          sta      ddra            ; Port A O/P Port, Display Off,Buzzer off

InitB     lda      #%110101       ; Pb5,Pb4,Pb2  and Pb0 in O/P Mode.
                                  ; Pb3 and Pb1 in I/P Mode.
          sta      portb
          lda      #%110101       ; RD,WR and Latch Enable High,
          sta      ddrb           ; Latch Transparant
          bclr     Pb0,portb      ; Latch Latched
**************************************************************************************
* Clear : Clear all memory locations.Later the locations are used for storing the
* pending calls.
*************************************************************************************
Clear1     clra                   ; Ram claring
           sta     copr           ; Cick WatchDog Timer
Clear2     ldx     #$c0
Clear3     sta     ,x
           incx
           cpx     #$ff           ; Check all the locations are cleared?
           blo     clear3
           sta     ,x
*************************************************************************************
* Assign : Assigns the memory location for storing the recent and  pending calls.
*************************************************************************************
Assign     lda     #$D3
           sta     Address
           sta     Disp_Address
**************************************************************************************
* Identify : This part of the programm identifies the location of calling point
*           from the adc data. The module is divided in two parts.In first part
*           the circuit1(adc_data1) output is analysed while in second part the
*           the circuit2(adc_data2) output is analysed.
*           The call point numbers will be stored in ram starting from address
*           D3 Hex.
*           ADC data is compared with already stored calculated values and
*           accordingly the calling Point destination will be  confirmed.
*           The Calling Point destination will be confirmed if the data persists
*           100 miliseconds.
*************************************************************************************
Ident00    lda      Address                ; If Address=F6 indicates that all the
           cmp      #$F6                   ; 36 memory locations are full
           bls      Ident03                ;

Ident01    lda      Disp_Address           ; Wait till all the calling points
           cmp      #$F6                   ; are displayed.
           bhi      Ident02
           jmp      Mode00
*************************************************************************************
* When Disp_Address points the memory location F7,it indicates that no call
* is pending and the addresss pointers are re-initialised at starting address
* i.e. D3 hex.
*************************************************************************************
Ident02    lda      #$D3
           sta      Address
           sta      Disp_Address
*************************************************************************************
* Ident03 : Scan circuit1 output.
*************************************************************************************
Ident03    lda      adc_data1             ; adc_data1 stores circuit1 output.
           cmp      #!07
           bhi      Ident05

Ident04    clr      Count1                ; No call is there.
           clr      Number1
           bra      Ident20               ; Check other circuit
***********************************************************************************
* Ident05 : Adc data is greater than 07,Check for the calling point number.
* The range of data for each calling point is stored at memory locations from
* 0700hex to 0712hex.
***********************************************************************************
Ident05    clrx                            ; Clear the Register X.Reg X acts as
                                           ; memory pointer.

Ident06    incx

Ident07    lda      $0700,x                ; Check if the ciccuit1 output lies
           cmp      adc_data1              ; in the range?
           bhi      Ident10                ; Range is found

Ident08    cpx      #!17                   ; Is all the ranges are checked?
           blo      Ident06
Ident09    incx                           ; increment the memory pointer
*************************************************************************************
* Ident10 : The range in which the adc_data lies is found. Confirm the perticular
* key press if the data persists for 100 miliseconds.
* reg Count1 stores the number of scanning times for which the same data persists.
* reg number1 temporaly stores the calling point number of circuit1.The number
* will be confirmed if the data persists for 100 milisecond(10 scannings )
*************************************************************************************
Ident10    lda      Count1                 ; Is it a first key press?
           cmp      #!00
           bne      Ident12

Ident11    stx      Number1               ; store the calling point number temporaly.
           inc      Count1
           bra      Ident20
*************************************************************************************
* Ident12 : Check if the Key Press persists for 100 Miliseconds or not.
* Also check whether it is the  same key press?
*************************************************************************************
Ident12    inc      Count1

Ident13    cpx      Number1          ; Check is it a same key press?
           beq      Ident15          ; Yes,

Ident14    clr      Number1          ; Key Press is different; start again.
           clr      Count1
           bra      Ident20          ; Check the other circuit

Ident15    lda      Count1
           cmp      #!10
           bls      Ident20          ; 10 scannings are not over,check other circut.
*************************************************************************************
*Ident16 : If the Call point number is already stored, Do not accept it again
*************************************************************************************
Ident16    ldx      #$D3             ; Memory pointer is initiated at D3hex

Ident17    lda      ,x               ; Check the data stored memory pointed by
           cmp      Number1          ; the memory pointer.
           beq      Ident19          ; The call point is already stored

Ident18    incx                      ; Increment the Memoty pointer
           cpx      #$F6             ; Is it a last memory location?
           bls      Ident17
************************************************************************************
*  A fresh call is there,store the call point number in ram
************************************************************************************
           lda      Number1          ; Number 1 stores the call no.data
           ldx      Address
           sta      ,x
           inc      Address
*************************************************************************************
* Ident19 : Get ready to read new data.
*************************************************************************************
Ident19    clr      Number1
           clr      Count1
***********************************************************************************
***********************************************************************************
***********************************************************************************
* Ident20 : Scanning of Circuit2
*         : The output of circuit2 is stored in adc_data2.
*************************************************************************************
Ident20    lda      adc_data2
           cmp      #!07
           bhi      Ident22

Ident21    clr      Count2
           clr      Number2
           bra      Mode00                ; Check other circuit
***********************************************************************************
* Ident22 : Adc data is greater than 07,Check for the calling point number.
***********************************************************************************
Ident22    clrx                            ; Clear the Register X

Ident23    incx

Ident24    lda      $0700,x
           cmp      adc_data2
           bhi      Ident26

Ident25    cpx      #!17
           blo      Ident23
           incx
*************************************************************************************
* Ident26 : The range in which the adc_data lies is found. Confirm the perticular
*          key press if the data persists for 100 miliseconds.
*          reg Count1 stores the number of scanning times for which the same data
*          persists.
*          reg number1 temporaly stores the calling point number of circuit1.
*          The number will be confirmed if the same data persists for 100 milisecond
*          (10 scannings )
*************************************************************************************
Ident26    lda      Count2                 ; Is it a first key press?
           cmp      #!00
           bne      Ident28

Ident27    txa                             ; Set msb high to indicate circuit2 data
           ora      #%10000000
           sta      Number2
           inc      Count2
           bra      Mode00
*************************************************************************************
* Ident28 : Check if the Keypress persists for 100 Miliseconds or not.
* Also check whether it is a same key press?
*************************************************************************************
Ident28    inc      Count2

Ident29    txa
           ora      #%10000000
           cmp      Number2
           beq      Ident31

Ident30    clr      Number2          ; Not valid key press
           clr      Count2
           bra      Mode00           ;

Ident31    lda      Count2
           cmp      #!10
           bls      Mode00          ; 10 scannings are not finished.
*************************************************************************************
* Ident32 : If the Call point number is already stored, Do not accept it again
*************************************************************************************
Ident32    ldx      #$D3

Ident33    lda      ,x
           cmp      Number2
           beq      Ident36

Ident34    incx
           cpx      #$F6
           bls      Ident33

Ident35    lda      Number2          ; Number2 stores the call no.data
           ldx      Address
           sta      ,x
           inc      Address
*************************************************************************************
* Ident36 : The number is already stored in memory,Do not repeat it.
*************************************************************************************
Ident36    clr      Number2
           clr      Count2
***********************************************************************************
* Mode : This part of the programme reads the status of the Mode key.Accordingly
* the format of the display will be decided.
* For Mode 0: The Call Points will be displayed as 001 to 018 for circuit1
*           and 019 to 036 for circuit2.
* For Mode 1: The call points will be displayed as 001 to 018  for circuit1 and
*           and 101 to 118 for circuit2.
* Mode selector switch is connected to pin Pb1 of PortB.
***********************************************************************************
Mode00     brset     Pb1,Portb,Mode07      ; check is it a  mode 1or 2.
***********************************************************************************
* Mode1 : Call points will be decided from 001 to 036
*        Display the calling point number pointed by register Disp_Address.
***********************************************************************************
Mode01     ldx       Disp_Address
           lda       ,x
           cmp       #!00            ; Is it 00?
           beq       Mode06
***********************************************************************************
* Mode02 : Data conditioning of circuit2 display.(Display 001 to 018)
***********************************************************************************
Mode02     ldx       Disp_Address
           lda       ,x
           sta       Data_Out1

Mode03     brset     7,Data_Out1,Mode05       ; Msb of the data decides whether
                                              ; it is circuit1 or circuit2 data
Mode04     clr       Data_Out2                ;
           bset      6,Buzzer                 ; Buzzer on
           bra       Discon00
***********************************************************************************
* Mode05 : Data conditioning of circuit2 display.(Display 019 to 036)
***********************************************************************************
Mode05     bclr      7,Data_Out1
           lda       Data_Out1
           add       #!18                 ; Add 18 so that display will be from 19
           sta       Data_Out1
           clr       Data_Out2
           bset      6,Buzzer
           bra       Discon00
***********************************************************************************
* Mode06 : The data is 00.It indicates that no key press is found.
*         Dispaly 000 and Buzzer off.
***********************************************************************************
Mode06     clr       Data_Out1
           clr       Data_Out2
           clr       Buzzer
           bra       Discon00
***********************************************************************************
* Mode07 : For Mode 1 display.
*        : The Call points will be displayed as 001 to 018  and 101 to118.
***********************************************************************************
Mode07     ldx       Disp_Address
           lda       ,x
           cmp       #!00
           beq       Mode12
***********************************************************************************
* Mode08 : For 001 to 018
***********************************************************************************
Mode08     ldx       Disp_Address
           lda       ,x
           sta       Data_Out1

Mode09     brset     7,Data_Out1,Mode11

Mode10     clr       Data_Out2          ; Display will be 001 to 018
           bset      6,Buzzer
           bra       Discon00
***********************************************************************************
* Mode11 : For 101 to 118
***********************************************************************************
Mode11     bclr      7,Data_Out1
           lda       #!01               ; Display will be 101 to 118.
           sta       Data_Out2
           bset      6,Buzzer
           bra       Discon00
***********************************************************************************
* Mode12: No Key press is found; Display 000,Buzzer off.
***********************************************************************************
Mode12     clr       Data_Out1
           clr       Data_Out2
           clr       Buzzer
***********************************************************************************
* Discon:- This part of the programme gets the BCD equivalant of the hex data.
*       The data in all the stages is in hex. For display purpase,the data should
*       be in BCD format.
* Data_Out1 and Data_Out2 stores the data to be displayed in hex.
* Digit_1,Digit_2 and Digit_3 stores the data in BCD format.
*      First the hex data is converted to decimal equivalant by adding 06 or its
*      multiple ( for 0 to 9 hex add 00, for 0ahex to 13hex add 06, for14hex to
*      1d hex add 0c hex and for 1e to 27 hex add 12hex.)
************************************************************************************
Discon00     lda     Data_Out1          ;
             clr     Digit_1

Discon01     sub     #$0a               ; Substaract 10 decimal
             bcs     Discon02
             inc     digit_1
             bra     Discon01

Discon02     lda     digit_1           ; Get the multiple of 6
             ldx     #$06
             mul
             add     Data_Out1
             sta     Data_Out1        ; equivalant of hex in decimal.

Discon03     clr     Digit_1
             clr     Digit_2
             clr     Digit_3
***********************************************************************************
* Discon04 : Convert the decimal to bcd one.
************************************************************************************
Discon04     lda     Data_Out1
             and     #%00001111
             sta     digit_1        ; bcd equivalant of lsb of Data_Out1

Discon05     lda     Data_out1
             and     #%11110000
             lsra
             lsra
             lsra
             lsra
             sta     digit_2       ; bcd equivalant of Msb of Data_Out1

Discon06     lda     Data_out2
             and     #%00001111
             sta     digit_3      ; bcd equivalant of lsb of Data_Out1
**********************************************************************************
*Discon07 : Get the Display equivalant of each digit.
* The bcd of each digit is fed to the BCD to Seven segement convertor 7447.
* The display equivalant( as per the hardware arrengement ) is stored from 7c0 hex
* onwords.
* This part of the program gets the display equivalant of each bcd number.
* Position_1,Position_2 and Position_3 stores the data to be displayed.
**********************************************************************************
Discon07    lda     digit_1
            and     #%00001111
            tax
            lda     $07c0,x
            ora     #%00000110
            ora     Buzzer
            sta     position_1    ; Digit1 data
**********************************************************************************
Discon08    lda     digit_2
            and     #%00001111
            tax
            lda     $07c0,x
            ora     #%00000101
            ora     Buzzer
            sta     position_2    ; Digit2 data
**********************************************************************************
Discon09    lda     digit_3
            and     #%00001111
            tax
            lda     $07c0,x
            ora     #%00000011
            ora     Buzzer
            sta     position_3     ; Digit3 data
**********************************************************************************
* Wait :- As scanning is done after 10 miliseconds, Controller is in low power mode
*        till fresh data is available.
***********************************************************************************
Wait       wait
           jmp      Ident00
***********************************************************************************
* Timer :- This is a Timer interrupt service routine.The 16 bit internal Timer of
*       the Microcontroller is software programmed to give interrupt after every
*       10 miliseconds.During the Timer interrupt service routine two tasks are
*       completed.
*       i) Refreshing of multiplexed displays.
*       As the it very essential to refresh the multiplexed display at a frequency
*       of 50Hz or more;during this interrupt routine displays will be refreshed.
*       This gives a refreshing frequency of 100Hz.
*       ii) Scanning of Calling Points.
*       Both the circuits are scanned and the digital equivalant of output voltages
*       will be stored in two registers.
***********************************************************************************
Timer       bset    rtifr,tscr
            clra
            sta     Copr            ; kick the watchdog timer
***********************************************************************************
* Timer01 : Take care of the debounce time.
***********************************************************************************
Timer01     lda     Debounce
            cmp     #!100
            bhs     Timer03

Timer02     inc     Debounce
            bra     Disp00
Timer03     lda     #!101
            sta     Debounce
************************************************************************************
* Refreshing of Displays.
************************************************************************************
Disp00     lda      #%10111111
           ora      Buzzer
           sta      Porta
           lda      #$ff
           sta      ddra                ; Assign  Porta in Output mode.
           bset     Pb0,portb           ; Make the Latch transparant.
************************************************************************************
* Disp01 : Refresh the digit1.Keep the digit1 on for 1 milisecond.
************************************************************************************
Disp01     lda       position_1         ; Digit 1 Display
           sta       porta
Disp02     jsr       Delay
************************************************************************************
* Disp03 : Refresh the digit2.Keep the digit2 on for 1 milisecond.
************************************************************************************
Disp03     lda       position_2         ; Digit 2 Display
           sta       porta
Disp04     jsr       Delay
***********************************************************************************
* Disp06 : Refresh the digit3.Keep the digit3 on for 1 milisecond.
************************************************************************************
Disp06     lda       position_3
           sta       porta
Disp07     jsr       Delay
************************************************************************************
* Disp08: Refreshing is over. Switch of all the digits to save the power.Also Make
*         the latch Non Transperant so any changes on the Port A bus will not change
*         the status of displays.
************************************************************************************
Disp08     lda       #%10111111
           ora       Buzzer
           sta       Porta
           bclr      Pb0,portb          ; Latch Non Trasparant
************************************************************************************
* Adc: Scanning of the Calling Points.
*      ADC is used for reading the output voltages of Circuit 1 and Circuit2.
*      Multiplexer 4051 is used for selecting the circuit 1 or 2.
*      While reading the Adc data,Port A is assigned as input port. Port B pins are
*      used for providing the control signals. End of Conversion is indicated by
*      Intr signal.
*      The digital equivalants of circuit1 and 2 are stored in registers adc_data1
*      and adc_data2.
*      At the end of conversion,the Port A is assigned as output port again.
************************************************************************************
* Adc00 : Reading of Circuit1 output.
************************************************************************************
Adc00     lda      #$00
          sta      ddra                 ; Take Port A in Input mode.
          bclr     pb4,portb            ; Ensure Write signal to low

Adc01     jsr      Delay2               ; Keep it low.
Adc02     bset     pb4,portb            ; Write high,Conversion starts.

Adc03     lda      Portb                ; Wait for End of conversion.Intr signal
                                        ; goes low at the end of conversion.
          and      #%00001000
          cmp      #%00000000
          bne      Adc03

Adc04     bclr     pb5,portb            ; Read low

Adc05     jsr      Delay2

Adc06     lda      porta                ; Data is available on data bus of adc.
          sta      adc_data1            ; ADC data is stored

Adc07     bset     pb5,portb            ; Read high
************************************************************************************
* Adc08 : Reading of Circuit2 output.
************************************************************************************
Adc08     bclr     Pb2,Portb            ; Select circuit2  using multiplexer.
          bclr     pb4,portb            ; Write low

Adc09     jsr      Delay
Adc10     bset     pb4,portb            ; Write high,Conversion starts.

Adc11     lda      Portb                ; Read Intr signal from adc
          and      #%00001000
          cmp      #%00000000
          bne      Adc11

Adc12     bclr     pb5,portb            ; Read low

Adc13     jsr      Delay2
Adc14     lda      porta                ; Data is available on data bus.
          sta      adc_data2            ; ADC data is stored

Adc15     bset     pb5,portb            ; Read high
          bset     Pb2,Portb            ; Circuit 1 Selected for next data read.

Adc16     lda      #$ff                 ; Port A in Input mode.
          sta      porta
          sta      ddra
          rti
**************************************************************************************
* Snooze:Here the Buzzer can be snoozed by receiving the call.A Call Acknowledge key
* is used for this purpose. The Call Acknowledge key generates the Interrupt
* request.Following Interrupt service routine snoozes as well as displays any
* pending call.A key debounce time of 1 second is provided.
*************************************************************************************
snooze     brclr   6,Buzzer,snooze4

snooze1    lda     Debounce
           cmp     #!100
           bls     snooze4           ; Wait for debounce period of 1 second.

snooze2    ldx      Disp_Address
           clra
           sta      ,x
           inc      Disp_Address     ; Display the pending call

snooze3    clr      Buzzer           ; Snooze the buzzer.
           clr      Debounce

snooze4    rti
*************************************************************************************
* Delay : Provides delay of
*************************************************************************************
Delay     ldx       #!250

Delay1    decx
          cpx       #$00
          bne       Delay1
          rts
*************************************************************************************
* Delay2: Provides delay of
*************************************************************************************
Delay2    ldx       #!150

Delay3    decx
          cpx       #$00
          bne       Delay3
          rts
*************************************************************************************

                              org $0701
       fcb   !15,!26,!38,!50,!62,!72,!82,!92,!103,!114
       fcb   !125,!137,!147,!156,!170,!188,!200
************************************************************************************
                              org $07c0
       fcb   $00,$80,$10,$90,$08,$88,$18,$98,$20,$a0
*************************************************************************************















